/**
 *
 */
package de.intevation.gnv.transition;

import java.util.ArrayList;
import java.util.Collection;

import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import de.intevation.gnv.geobackend.base.Result;
import de.intevation.gnv.transition.describedata.DefaultMinMaxDescribeData;
import de.intevation.gnv.transition.describedata.DescribeData;
import de.intevation.gnv.transition.describedata.MinMaxDescribeData;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class MinMaxTransition extends TransitionBase {
    
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(MinMaxTransition.class);
    
    /**
     * Constructor
     */
    public MinMaxTransition() {
        super();
    }
    /**
     * @see de.intevation.gnv.transition.TransitionBase#purifyResult(java.util.Collection)
     */
    @Override
    protected void purifyResult(Collection<Result> result) {
        log.debug("MinMaxTransition.purifyResult");
        if (this.descibeData == null){
            this.descibeData = new ArrayList<Object>();
        }
        if (result != null && result.size() == 1){
            
            Object[] names = this.inputValueNames.toArray();
            String minName = names[names.length-2].toString();
            String maxName = names[names.length-1].toString();
            Result value = result.iterator().next();
            DescribeData describeData = new DefaultMinMaxDescribeData(minName, maxName,value.getObject("MIN"), value.getObject("MAX"));
            log.debug(describeData.toString());
            this.descibeData.add(describeData);
        }else{
            log.warn("Result cannot be handled as MinMax Resultset");
        }
        
    }

    /**
     * @see de.intevation.gnv.transition.Transition#validate()
     */
    public boolean validate() {
        // TODO: Implement ME
        return true;
    }

}
